const fs = require('fs')
const path = require('path')
const eui = require('./eui.js')

function getThemeData () {
  const theme = fs.readFileSync(path.join(process.cwd(), 'bin-release/vivo-qgame/engine/resource/default.thm.json'), 'utf-8')
  return JSON.parse(theme)
}

function main () {
  fs.appendFileSync(path.join(process.cwd(), 'bin-release/vivo-qgame/engine/eui.vivo.js'), `\n var EXML;(function (EXML) {var parser = new eui.sys.EXMLParser();var requestPool = [];var callBackMap = {};var parsedClasses = {};var $prefixURL = "";var themeClazzes = {`)
  // 获取资源的json数据
  const data = getThemeData()
  // 将资源转化成函数写入skin/eui.js
  const exmls = data.exmls
  const EXMLParser = new eui.sys.EXMLParser()
  for (let i = 0, len = exmls.length; i < len; i++) {
    const exml = exmls[i]
    const map = EXMLParser.parse(exml.content)
    const code = map.code
    const className = map.className
    fs.appendFileSync(path.join(process.cwd(), 'bin-release/vivo-qgame/engine/eui.vivo.js'), '"' + exml.path + '"' + ':{clazz:parsedClasses["' + exml.path + '"] = (function(){return ' + code + '})(),className:"' + className + '"},\n')
  }
  fs.appendFileSync(path.join(process.cwd(), 'bin-release/vivo-qgame/engine/eui.vivo.js'), `}
          Object.defineProperty(EXML, "prefixURL", {
              get: function () { return $prefixURL; },
              set: function (value) { $prefixURL = value; },
              enumerable: true,
              configurable: true
          });
          function parse(text) {return parser.parse(text);}
          EXML.parse = parse;
      
          function load(url, callBack, thisObject, useCache) {
              if (useCache === void 0) { useCache = false; }
              if (true) {
                  if (!url) {
                      egret.$error(1003, "url");
                  }
              }
              if (useCache && (url in parsedClasses)) {
                  callBack && callBack.call(thisObject, parsedClasses[url], url);
                  return;
              }
              var list = callBackMap[url];
              if (list) {
                  list.push([callBack, thisObject]);
                  return;
              }
              callBackMap[url] = [[callBack, thisObject]];
              request(url, $parseURLContent);
          }
          EXML.load = load;
      
          function $loadAll(urls, callBack, thisObject, useCache) {
              if (useCache === void 0) { useCache = false; }
              if (!urls || urls.length == 0) {
                  callBack && callBack.call(thisObject, [], urls);
                  return;
              }
              var exmlContents = [];
              urls.forEach(function (url) {
                  var loaded = function (url, text) {
                      exmlContents[url] = text;
                      exmlContents.push(url);
                      if (exmlContents.length == urls.length)
                          onLoadAllFinished(urls, exmlContents, callBack, thisObject);
                  };
                  if (useCache && (url in parsedClasses)) {
                      loaded(url, "");
                      return;
                  }
                  request(url, loaded);
              });
          }
          EXML.$loadAll = $loadAll;
      
          function onLoadAllFinished(urls, exmlContents, callBack, thisObject) {
              var clazzes = [];
              urls.forEach(function (url, i) {
                  if ((url in parsedClasses) && !exmlContents[url]) {
                      clazzes[i] = parsedClasses[url];
                      return;
                  }
                  var text = exmlContents[url];
                  var clazz = $parseURLContent(url, text);
                  clazzes[i] = clazz;
              });
              callBack && callBack.call(thisObject, clazzes, urls);
          }
      
          function $parseURLContentAsJs(url, text, className) {
              var clazz = null;
              if (text) {
                  clazz = parser.$parseCode(text, className);
              }
              if (url) {
                  parsedClasses[url] = clazz;
                  var list = callBackMap[url];
                  delete callBackMap[url];
                  var length_30 = list ? list.length : 0;
                  for (var i = 0; i < length_30; i++) {
                      var arr = list[i];
                      if (arr[0] && arr[1])
                          arr[0].call(arr[1], clazz, url);
                  }
              }
              return clazz;
          }
          EXML.$parseURLContentAsJs = $parseURLContentAsJs;
      
          function $parseURLContent(url, text) {
              var clazz = null;
              var className = ""
              if (text) {
                  try {
                      clazz = themeClazzes[url].clazz
                      className = themeClazzes[url].className
                      egret.registerClass(clazz, className);
                      var paths = className.split(".");
                      var length_16 = paths.length;
                      var definition = __global;
                      for (var i = 0; i < length_16 - 1; i++) {
                          var path = paths[i];
                          definition = definition[path] || (definition[path] = {});
                      }
                      if (definition[paths[length_16 - 1]]) {
                          if (true && !parsedClasses[className]) {
                              egret.$warn(2101, className, toXMLString(xmlData));
                          }
                      }
                      else {
                          if (true) {
                              parsedClasses[className] = true;
                          }
                          definition[paths[length_16 - 1]] = clazz;
                      }
                  }
                  catch (e) {
                      console.error(url + \"\\n\" + e.message);
                  }
              }
              if (url) {
                  parsedClasses[url] = clazz;
                  var list = callBackMap[url];
                  delete callBackMap[url];
                  var length_31 = list ? list.length : 0;
                  for (var i = 0; i < length_31; i++) {
                      var arr = list[i];
                      if (arr[0] && arr[1])
                          arr[0].call(arr[1], clazz, url);
                  }
              }
              return clazz;
          }
          EXML.$parseURLContent = $parseURLContent;
      
          function request(url, callback) {
              var openUrl = url;
              if (url.indexOf("://") == -1) {
                  openUrl = $prefixURL + url;
              }
              var onConfigLoaded = function (str) {
                  if (!str) {
                      str = "";
                  }
                  callback(url, str);
              };
              eui.getTheme(openUrl, onConfigLoaded);
          }
      })(EXML || (EXML = {}));`)
}

module.exports = main
