processor_1.SoundProcessor = {
    onLoadStart: function (host, resource) {
        var sound = new egret.Sound();
        return promisify(sound, resource)
    },
    onRemoveStart: function (host, resource) {
    }
}

function promisify(loader, resource) {
    var _this = this;
    if (loader instanceof egret.web.HtmlSound) {
        return new Promise(function (resolve, reject) {
            var onSuccess = function (e) {
                resolve(loader);
            };
            var onError = function () {
                var e = new RES.ResourceManagerError(1001, resource.url);
                reject(e);
            };
            loader.addEventListener(egret.Event.COMPLETE, onSuccess, _this);
            loader.addEventListener(egret.IOErrorEvent.IO_ERROR, onError, _this);
            var soundPath = RES.getVirtualUrl && RES.getVirtualUrl(resource.root + resource.url) || (resource.root + resource.url);
            loader.load(soundPath);
        });
    } else {
        return new Promise(function (resolve, reject) {
            var onSuccess = function () {
                var texture = loader['data'] ? loader['data'] : loader['response'];
                resolve(texture);
            };
            var onError = function () {
                var e = new RES.ResourceManagerError(1001, resource.url);
                reject(e);
            };
            loader.addEventListener(egret.Event.COMPLETE, onSuccess, _this);
            loader.addEventListener(egret.IOErrorEvent.IO_ERROR, onError, _this);
        });
    }
}