var HtmlSound = (function (_super) {
  __extends(HtmlSound, _super)
  function HtmlSound () {
    var _this = _super.call(this) || this
    _this.loaded = false
    return _this
  }
  Object.defineProperty(HtmlSound.prototype, 'length', {
    get: function () {
      if (this.originAudio) {
        return this.originAudio.duration
      }
      throw new Error('sound not loaded!')
    },
    enumerable: true,
    configurable: true
  })
    /**
     * 是否是网络音频地址
     * @param url
     */
  HtmlSound.prototype.isNetUrl = function (url) {
    return -1 != url.indexOf('http://') || -1 != url.indexOf('HTTP://') || -1 != url.indexOf('https://') || -1 != url.indexOf('HTTPS://')
  }
    /**
     * @inheritDoc
     */
  HtmlSound.prototype.load = function (url) {
    var self = this;
    this.url = url;
    if (true && !url) {
        egret.$error(3002);
    }
    var audio = window.qg.createInnerAudioContext();
    this.isNetUrl(this.url) ? window.qg.download({
        url: this.url,
        success: function (e) {
            audio.src = e.tempFilePath;
            self.loaded = true;
        }
    }) : (audio.src = url, this.loaded = true);
    this.originAudio = audio;
    if (HtmlSound.clearAudios[this.url]) {
        delete HtmlSound.clearAudios[this.url];
    }
    HtmlSound.$recycle(this.url, audio);
    audio.play();
    (function getLoadStatus() {
        if (audio.duration > 0) {
            self.length = audio.duration;
            console.log(self.length);
            self.dispatchEventWith(egret.Event.COMPLETE);
            audio.stop();
        }
        else {
            setTimeout(getLoadStatus,100)
        }
    })()
  };
    /**
     * @inheritDoc
     */
  HtmlSound.prototype.play = function (startTime, loops) {
    startTime = +startTime || 0
    loops = +loops || 0
    if (true && this.loaded == false) {
      egret.$error(1049)
    }
    var audio = HtmlSound.$pop(this.url)
    if (audio == null) {
      audio = this.originAudio
    }

    audio.autoplay = true
    var channel = new web.HtmlSoundChannel(audio)
    channel.$url = this.url
    channel.$loops = loops
    channel.$startTime = startTime
    channel.$play()
    egret.sys.$pushSoundChannel(channel)
    return channel
  }
    /**
     * @inheritDoc
     */
  HtmlSound.prototype.close = function () {
    if (this.loaded == false && this.originAudio)
      this.originAudio.src = ''
    if (this.originAudio)
      this.originAudio = null
    HtmlSound.$clear(this.url)
  }
  HtmlSound.$clear = function (url) {
    HtmlSound.clearAudios[url] = true
    var array = HtmlSound.audios[url]
    if (array) {
      array.length = 0
    }
  }
  HtmlSound.$pop = function (url) {
    var array = HtmlSound.audios[url]
    if (array && array.length > 0) {
      return array.pop()
    }
    return null
  }
  HtmlSound.$recycle = function (url, audio) {
    if (HtmlSound.clearAudios[url]) {
      return
    }
    var array = HtmlSound.audios[url]
    if (HtmlSound.audios[url] == null) {
      array = HtmlSound.audios[url] = []
    }
    array.push(audio)
  }
  HtmlSound.MUSIC = 'music'
  HtmlSound.EFFECT = 'effect'
  HtmlSound.audios = {}
  HtmlSound.clearAudios = {}
  return HtmlSound
}(egret.EventDispatcher))

var HtmlSoundChannel = (function (_super) {
  __extends(HtmlSoundChannel, _super)
  function HtmlSoundChannel (audio) {
    var _this = _super.call(this) || this
    _this.$startTime = 0
    _this.audio = null
    // 声音是否已经播放完成
    _this.isStopped = false
    // _this.canPlay = function () {
    //     _this.audio.removeEventListener("canplay", _this.canPlay);
    //     try {
    //         _this.audio.currentTime = _this.$startTime;
    //     }
    //     catch (e) {
    //     }
    //     finally {
    //         _this.audio.play();
    //     }
    // };
    _this.onPlayEnd = function () {
      if (_this.$loops == 1) {
        _this.stop()
        _this.dispatchEventWith(egret.Event.SOUND_COMPLETE)
        return
      }
      if (_this.$loops > 0) {
        _this.$loops--
      }
      // ///////////
      // this.audio.load();
      _this.$play()
    }
    _this._volume = 1
    // audio.addEventListener("ended", _this.onPlayEnd);
    audio.onEnded(_this.onPlayEnd.bind(_this))
    _this.audio = audio
    return _this
  }
  HtmlSoundChannel.prototype.$play = function () {
    if (this.isStopped) {
      egret.$error(1036)
      return
    }
    // try {
    // this.audio.pause();
    this.audio.volume = this._volume
    this.audio.currentTime = this.$startTime
    // }
    // catch (e) {
    //     this.audio.addEventListener("canplay", this.canPlay);
    //     return;
    // }
    this.audio.play()
  }
    /**
     * @private
     * @inheritDoc
     */
  HtmlSoundChannel.prototype.stop = function () {
    if (!this.audio)
      return
    if (!this.isStopped) {
      egret.sys.$popSoundChannel(this)
    }
    this.isStopped = true
    var audio = this.audio
    audio.offEnded(this.onPlayEnd.bind(this))
    // audio.removeEventListener("ended", this.onPlayEnd);
    // audio.removeEventListener("canplay", this.canPlay);
    audio.volume = 0
    this._volume = 0
    this.audio = null
    var url = this.$url
    // 延迟一定时间再停止，规避chrome报错
    window.setTimeout(function () {
      audio.pause()
      web.HtmlSound.$recycle(url, audio)
    }, 200)
  }
  Object.defineProperty(HtmlSoundChannel.prototype, 'volume', {
    get: function () {
      return this._volume
    },
    set: function (value) {
      if (this.isStopped) {
        egret.$error(1036)
        return
      }
      this._volume = value
      if (!this.audio)
        return
      this.audio.volume = value
    },
    enumerable: true,
    configurable: true
  })
  Object.defineProperty(HtmlSoundChannel.prototype, 'position', {
        /**
         * @private
         * @inheritDoc
         */
    get: function () {
      if (!this.audio)
        return 0
      return this.audio.currentTime
    },
    enumerable: true,
    configurable: true
  })
  return HtmlSoundChannel
}(egret.EventDispatcher))

WebGLRenderer.prototype.renderText = function (node, buffer) {
  var width = node.width - node.x
  var height = node.height - node.y
  if (width <= 0 || height <= 0 || !width || !height || node.drawData.length == 0) {
    return
  }
  var canvasScaleX = egret.sys.DisplayList.$canvasScaleX
  var canvasScaleY = egret.sys.DisplayList.$canvasScaleY
  var maxTextureSize = buffer.context.$maxTextureSize
  if (width * canvasScaleX > maxTextureSize) {
    canvasScaleX *= maxTextureSize / (width * canvasScaleX)
  }
  if (height * canvasScaleY > maxTextureSize) {
    canvasScaleY *= maxTextureSize / (height * canvasScaleY)
  }
  width *= canvasScaleX
  height *= canvasScaleY
  var x = node.x * canvasScaleX
  var y = node.y * canvasScaleY
  if (node.$canvasScaleX != canvasScaleX || node.$canvasScaleY != canvasScaleY) {
    node.$canvasScaleX = canvasScaleX
    node.$canvasScaleY = canvasScaleY
    node.dirtyRender = true
  }
  if (!this.canvasRenderBuffer || !this.canvasRenderBuffer.context) {
    this.canvasRenderer = new egret.CanvasRenderer()
    this.canvasRenderBuffer = new web.CanvasRenderBuffer(width, height)
  }
  else if (node.dirtyRender) {
    this.canvasRenderBuffer.resize(width, height)
  }
  if (!this.canvasRenderBuffer.context) {
    return
  }
  if (canvasScaleX != 1 || canvasScaleY != 1) {
    this.canvasRenderBuffer.context.setTransform(canvasScaleX, 0, 0, canvasScaleY, 0, 0)
  }
  if (x || y) {
    if (node.dirtyRender) {
      this.canvasRenderBuffer.context.setTransform(canvasScaleX, 0, 0, canvasScaleY, -x, -y)
    }
    buffer.transform(1, 0, 0, 1, x / canvasScaleX, y / canvasScaleY)
  }
  else if (canvasScaleX != 1 || canvasScaleY != 1) {
    this.canvasRenderBuffer.context.setTransform(canvasScaleX, 0, 0, canvasScaleY, 0, 0)
  }
  if (node.dirtyRender) {
    var surface = this.canvasRenderBuffer.surface
    this.canvasRenderer.renderText(node, this.canvasRenderBuffer.context)
        // 拷贝canvas到texture
    var texture = node.$texture
    if (!texture) {
      texture = buffer.context.createTexture(surface)
      node.$texture = texture
    }
    else {
            // 重新拷贝新的图像
      buffer.context.updateTexture(texture, surface)
    }
    // 保存材质尺寸
    // node.$textureWidth = surface.width;
    // node.$textureHeight = surface.height;

    node.$textureWidth = surface.width * canvasScaleX
    node.$textureHeight = surface.height * canvasScaleY
  }
  var textureWidth = node.$textureWidth
  var textureHeight = node.$textureHeight
  buffer.context.drawTexture(node.$texture, 0, 0, textureWidth, textureHeight, 0, 0, textureWidth / canvasScaleX, textureHeight / canvasScaleY, textureWidth, textureHeight)
  if (x || y) {
    if (node.dirtyRender) {
      this.canvasRenderBuffer.context.setTransform(canvasScaleX, 0, 0, canvasScaleY, 0, 0)
        // this.canvasRenderBuffer.context.$offsetX = canvasScaleX * (-x) + canvasScaleX * canvasScaleX;
        // this.canvasRenderBuffer.context.$offsetY = canvasScaleY * (-y) + canvasScaleY * canvasScaleY;
    }
    buffer.transform(1, 0, 0, 1, -x / canvasScaleX, -y / canvasScaleY)
  }
  node.dirtyRender = false
}

WebPlayer.prototype.init = function (container, options) {
  var styleStr = container.getAttribute('data-show-fps-style') || '';
  var stylesArr = styleStr.split(',');
  var styles = {};
  for (var i = 0; i < stylesArr.length; i++) {
      var tempStyleArr = stylesArr[i].split(':');
      styles[tempStyleArr[0]] = tempStyleArr[1];
  }
  var option = {
    'entryClassName': 'Main',
    'scaleMode': container.getAttribute('data-scale-mode') || egret.StageScaleMode.NO_SCALE,
    'frameRate': +container.getAttribute('data-frame-rate') || 60,
    'contentWidth': +container.getAttribute('data-content-width') || 480,
    'contentHeight': +container.getAttribute('data-content-height') ||  720,
    'orientation': container.getAttribute('data-orientation') || egret.OrientationMode.AUTO,
    'maxTouches': 2,
    'textureScaleFactor': 1,
    'showPaintRect': options.renderMode == 'webgl' ? false : container.getAttribute('data-show-paint-rect') == 'true',
    'showFPS': container.getAttribute('data-show-fps') == 'true',
    'fpsStyles': styles,
    'showLog': false,
    'logFilter': null
  }
  var stage = new egret.Stage()
  stage.$screen = this
  stage.$scaleMode = option.scaleMode
  stage.$orientation = option.orientation
  stage.$maxTouches = option.maxTouches
  stage.frameRate = option.frameRate
  stage.textureScaleFactor = option.textureScaleFactor
  var buffer = new egret.sys.RenderBuffer(undefined, undefined, true)
  var canvas = buffer.surface
  this.attachCanvas(container, canvas)
  var webTouch = new web.WebTouchHandler(stage, canvas)
  var player = new egret.sys.Player(buffer, stage, option.entryClassName)
  egret.lifecycle.stage = stage
  egret.lifecycle.addLifecycleListener(web.WebLifeCycleHandler)
  var webInput = new web.HTMLInput()
  if (option.showFPS || option.showLog) {
    if (!egret.nativeRender) {
      player.displayFPS(option.showFPS, option.showLog, option.logFilter, option.fpsStyles)
    }
  }
  this.playerOption = option
  this.container = container
  this.canvas = canvas
  this.stage = stage
  this.player = player
  this.webTouchHandler = webTouch
  this.webInput = webInput
  egret.web.$cacheTextAdapter(webInput, stage, container, canvas)
  this.updateScreenSize()
  this.updateMaxTouches()
  player.start()
}
/**
 * 获取指定区域的像素
 */
CanvasRenderBuffer.prototype.getPixels = function (x, y, width, height) {
  if (width === void 0) {
    width = 1
  }

  if (height === void 0) {
    height = 1
  }
    // 适配处理（只修改了这里）
  if (qg) {
    return this.context.getImageData(x, y, width, height)
  } else {
    return this.context.getImageData(x, y, width, height).data
  }
}

var HTML5StageText = (function (_super) {
  __extends(HTML5StageText, _super)
  
  function HTML5StageText () {
    var _this = _super.call(this) || this
    _this._isNeedShow = false
    _this.inputElement = null
    _this.inputDiv = null
    _this._gscaleX = 0
    _this._gscaleY = 0
    _this.textValue = ''
    _this.colorValue = 0xffffff
    _this._styleInfoes = {}
    _this.onKeyboardComplete = _this.onKeyboardComplete.bind(_this)// qg 输入框适配
    _this.onKeyboardInput = _this.onKeyboardInput.bind(_this)// qg 输入框适配
    return _this
  }

  HTML5StageText.prototype.$setTextField = function (textfield) {
    this.$textfield = textfield
    return true
  }

  HTML5StageText.prototype.$addToStage = function () {
    this.htmlInput = egret.web.$getTextAdapter(this.$textfield)
  }

  HTML5StageText.prototype._initElement = function () {
    var point = this.$textfield.localToGlobal(0, 0)
    var x = point.x
    var y = point.y
    // let m = this.$textfield.$renderNode.renderMatrix;
    // let cX = m.a;
    // let cY = m.d;
    var scaleX = this.htmlInput.$scaleX
    var scaleY = this.htmlInput.$scaleY
    this.inputDiv.style.left = x * scaleX + 'px'
    this.inputDiv.style.top = y * scaleY + 'px'
    if (this.$textfield.multiline && this.$textfield.height > this.$textfield.size) {
      this.inputDiv.style.top = (y) * scaleY + 'px'
      this.inputElement.style.top = (-this.$textfield.lineSpacing / 2) * scaleY + 'px'
    }
    else {
      this.inputDiv.style.top = y * scaleY + 'px'
      this.inputElement.style.top = 0 + 'px'
    }
    var node = this.$textfield
    var cX = 1
    var cY = 1
    var rotation = 0
    while (node.parent) {
      cX *= node.scaleX
      cY *= node.scaleY
      rotation += node.rotation
      node = node.parent
    }
    var transformKey = egret.web.getPrefixStyleName('transform')
    this.inputDiv.style[transformKey] = 'rotate(' + rotation + 'deg)'
    this._gscaleX = scaleX * cX
    this._gscaleY = scaleY * cY
  }

  HTML5StageText.prototype.$show = function () {
    var info = {
      defaultValue: this.$textfield.text,
      multiple: this.$textfield.multiline,
      confirmHold: true,
      confirmType: 'done',
      fail: function (res) {
        console.log(res.errMsg)
      }
    }
    if (this.$textfield.maxChars) {
      info.maxLength = this.$textfield.maxChars
    }
    qg.showKeyboard(info)
    qg.onKeyboardConfirm(this.onKeyboardComplete)
    qg.onKeyboardComplete(this.onKeyboardComplete)
    qg.onKeyboardInput(this.onKeyboardInput)
    this.dispatchEvent(new egret.Event('focus'))
  }

  HTML5StageText.prototype.onKeyboardInput = function (data) {
    this.textValue = data.value
    egret.Event.dispatchEvent(this, 'updateText', false)
  }

  HTML5StageText.prototype.onKeyboardComplete = function (res) {
    this.$textfield.text = res.value
    this.$hide()
  }

  HTML5StageText.prototype.onBlurHandler = function () {
    this.htmlInput.clearInputElement()
    window.scrollTo(0, 0)
  }

  HTML5StageText.prototype.executeShow = function () {
    var self = this
    // 打开
    this.inputElement.value = this.$getText()
    if (this.inputElement.onblur == null) {
      this.inputElement.onblur = this.onBlurHandler.bind(this)
    }
    this.$resetStageText()
    if (this.$textfield.maxChars > 0) {
      this.inputElement.setAttribute('maxlength', this.$textfield.maxChars)
    }
    else {
      this.inputElement.removeAttribute('maxlength')
    }
    this.inputElement.selectionStart = this.inputElement.value.length
    this.inputElement.selectionEnd = this.inputElement.value.length
    this.inputElement.focus()
  }

  HTML5StageText.prototype.$hide = function () {
    qg.offKeyboardComplete()
    qg.offKeyboardConfirm()
    qg.offKeyboardInput()
    qg.hideKeyboard({})
    this.dispatchEvent(new egret.Event('blur'))
  }

  HTML5StageText.prototype.$getText = function () {
    if (!this.textValue) {
      this.textValue = ''
    }
    return this.textValue
  }

  HTML5StageText.prototype.$setText = function (value) {
    this.textValue = value
    this.resetText()
    return true
  }

  HTML5StageText.prototype.resetText = function () {
    if (this.inputElement) {
      this.inputElement.value = this.textValue
    }
  }

  HTML5StageText.prototype.$setColor = function (value) {
    this.colorValue = value
    this.resetColor()
    return true
  }

  HTML5StageText.prototype.resetColor = function () {
    if (this.inputElement) {
      this.setElementStyle('color', egret.toColorString(this.colorValue))
    }
  }

  HTML5StageText.prototype.$onBlur = function () {
  }

  HTML5StageText.prototype._onInput = function () {
    var self = this
    window.setTimeout(function () {
      if (self.inputElement && self.inputElement.selectionStart == self.inputElement.selectionEnd) {
        self.textValue = self.inputElement.value
        egret.Event.dispatchEvent(self, 'updateText', false)
      }
    }, 0)
  }
  HTML5StageText.prototype.setAreaHeight = function () {
    var textfield = this.$textfield
    if (textfield.multiline) {
      var textheight = egret.TextFieldUtils.$getTextHeight(textfield)
      if (textfield.height <= textfield.size) {
        this.setElementStyle('height', (textfield.size) * this._gscaleY + 'px')
        this.setElementStyle('padding', '0px')
        this.setElementStyle('lineHeight', (textfield.size) * this._gscaleY + 'px')
      }
      else if (textfield.height < textheight) {
        this.setElementStyle('height', (textfield.height) * this._gscaleY + 'px')
        this.setElementStyle('padding', '0px')
        this.setElementStyle('lineHeight', (textfield.size + textfield.lineSpacing) * this._gscaleY + 'px')
      }
            else {
        this.setElementStyle('height', (textheight + textfield.lineSpacing) * this._gscaleY + 'px')
        var rap = (textfield.height - textheight) * this._gscaleY
        var valign = egret.TextFieldUtils.$getValign(textfield)
        var top_1 = rap * valign
        var bottom = rap - top_1
        this.setElementStyle('padding', top_1 + 'px 0px ' + bottom + 'px 0px')
        this.setElementStyle('lineHeight', (textfield.size + textfield.lineSpacing) * this._gscaleY + 'px')
      }
    }
  }

  HTML5StageText.prototype._onClickHandler = function (e) {
    if (this._isNeedShow) {
      e.stopImmediatePropagation()
            // e.preventDefault();
      this._isNeedShow = false
      this.executeShow()
      this.dispatchEvent(new egret.Event('focus'))
    }
  }

  HTML5StageText.prototype._onDisconnect = function () {
    this.inputElement = null
    this.dispatchEvent(new egret.Event('blur'))
  }

  HTML5StageText.prototype.setElementStyle = function (style, value) {
    if (this.inputElement) {
      if (this._styleInfoes[style] != value) {
        this.inputElement.style[style] = value
                // this._styleInfoes[style] = value;
      }
    }
  }

  HTML5StageText.prototype.$removeFromStage = function () {
    if (this.inputElement) {
      this.htmlInput.disconnectStageText(this)
    }
  }
  // 修改位置
  HTML5StageText.prototype.$resetStageText = function () {
    if (this.inputElement) {
      var textfield = this.$textfield
      this.setElementStyle('fontFamily', textfield.fontFamily)
      this.setElementStyle('fontStyle', textfield.italic ? 'italic' : 'normal')
      this.setElementStyle('fontWeight', textfield.bold ? 'bold' : 'normal')
      this.setElementStyle('textAlign', textfield.textAlign)
      this.setElementStyle('fontSize', textfield.size * this._gscaleY + 'px')
      this.setElementStyle('color', egret.toColorString(textfield.textColor))
      var tw = void 0
      if (textfield.stage) {
        tw = textfield.localToGlobal(0, 0).x
        tw = Math.min(textfield.width, textfield.stage.stageWidth - tw)
      }
      else {
        tw = textfield.width
      }
      this.setElementStyle('width', tw * this._gscaleX + 'px')
      this.setElementStyle('verticalAlign', textfield.verticalAlign)
      if (textfield.multiline) {
        this.setAreaHeight()
      }
      else {
        this.setElementStyle('lineHeight', (textfield.size) * this._gscaleY + 'px')
        if (textfield.height < textfield.size) {
          this.setElementStyle('height', (textfield.size) * this._gscaleY + 'px')
          var bottom = (textfield.size / 2) * this._gscaleY
          this.setElementStyle('padding', '0px 0px ' + bottom + 'px 0px')
        }
        else {
          this.setElementStyle('height', (textfield.size) * this._gscaleY + 'px')
          var rap = (textfield.height - textfield.size) * this._gscaleY
          var valign = egret.TextFieldUtils.$getValign(textfield)
          var top_2 = rap * valign
          var bottom = rap - top_2
          if (bottom < textfield.size / 2 * this._gscaleY) {
            bottom = textfield.size / 2 * this._gscaleY
          }
          this.setElementStyle('padding', top_2 + 'px 0px ' + bottom + 'px 0px')
        }
      }
      this.inputDiv.style.clip = 'rect(0px ' + (textfield.width * this._gscaleX) + 'px ' + (textfield.height * this._gscaleY) + 'px 0px)'
      this.inputDiv.style.height = textfield.height * this._gscaleY + 'px'
      this.inputDiv.style.width = tw * this._gscaleX + 'px'
    }
  }
  return HTML5StageText
}(egret.EventDispatcher))

var WebHttpRequest = function (_super) {
  __extends(WebHttpRequest, _super)
  function WebHttpRequest () {
    var _this = _super.call(this) || this
    _this._url = ''
    _this._method = ''
    return _this
  }
  Object.defineProperty(WebHttpRequest.prototype, 'response', {
    get: function () {
      if (!this._xhr) {
        return null
      }
      if (this.data != undefined) {
        return this.data
      }
      if (this._xhr.response != undefined) {
        return this._xhr.response
      }
      if (this._responseType == 'text') {
        return this._xhr.responseText
      }
      if (this._responseType == 'arraybuffer' && /msie 9.0/i.test(navigator.userAgent)) {
        var w = window
        return w.convertResponseBodyToText(this._xhr['responseBody'])
      }
      if (this._responseType == 'document') {
        return this._xhr.responseXML
      }
      return null
    },
    enumerable: true,
    configurable: true
  })
  Object.defineProperty(WebHttpRequest.prototype, 'responseType', {
    get: function () {
      return this._responseType
    },
    set: function (value) {
      this._responseType = value
    },
    enumerable: true,
    configurable: true
  })
  Object.defineProperty(WebHttpRequest.prototype, 'withCredentials', {
    get: function () {
      return this._withCredentials
    },
    set: function (value) {
      this._withCredentials = value
    },
    enumerable: true,
    configurable: true
  })
  WebHttpRequest.prototype.getXHR = function () {
    if (window['XMLHttpRequest']) {
      return new window['XMLHttpRequest']()
    } else {
      return new ActiveXObject('MSXML2.XMLHTTP')
    }
  }
  WebHttpRequest.prototype.isNotHttpRequest = function (uri) {
    let url = (uri && (typeof uri === 'string') && uri.toLowerCase()) || this._url
    return !(~url.indexOf('http://') || ~url.indexOf('https://'))
  }
  WebHttpRequest.prototype.open = function (url, method) {
    if (method === void 0) {
      method = 'GET'
    }
    this._url = url
    this._method = method
    if (this._xhr) {
      this._xhr.abort()
      this._xhr = null
    }
    this._xhr = this.getXHR()
    if (!this.isNotHttpRequest(url)) {
      console.log(url)
      console.log('🌍 🌍 🌍 🌍 🌍 🌍 ')
      this._xhr.onreadystatechange = this.onReadyStateChange.bind(this)
      this._xhr.onprogress = this.updateProgress.bind(this)
      this._xhr.open(this._method, this._url, true)
    }
  }
  WebHttpRequest.prototype.send = function (data) {
    if (this.isNotHttpRequest()) {
      var that = this
            // i = window.qg.getFileSystemManager();
      qg.readFile({
        uri: that._url,
        encoding: 'arraybuffer' == that.responseType ? 'binary' : 'utf8',
        success: function (data) {
          that.data = data.text
          that.dispatchEventWith(egret.Event.COMPLETE)
        },
        fail: function () {
          that.dispatchEventWith(egret.IOErrorEvent.IO_ERROR)
        }
      })
    }
    else {
      if (this._responseType != null) {
        this._xhr.responseType = this._responseType
      }
      if (this._withCredentials != null) {
        this._xhr.withCredentials = this._withCredentials
      }
      if (this.headerObj) {
        for (var key in this.headerObj) {
          this._xhr.setRequestHeader(key, this.headerObj[key])
        }
      }
      this._xhr.send(data)
    }
  }
  WebHttpRequest.prototype.abort = function () {
    if (this._xhr) {
      this._xhr.abort()
    }
  }
  WebHttpRequest.prototype.getAllResponseHeaders = function () {
    if (!this._xhr) {
      return null
    }
    var result = this._xhr.getAllResponseHeaders()
    return result ? result : ''
  }
  WebHttpRequest.prototype.setRequestHeader = function (header, value) {
    if (!this.headerObj) {
      this.headerObj = {}
    }
    this.headerObj[header] = value
  }
  WebHttpRequest.prototype.getResponseHeader = function (header) {
    if (!this._xhr) {
      return null
    }
    var result = this._xhr.getResponseHeader(header)
    return result ? result : ''
  }
  WebHttpRequest.prototype.onReadyStateChange = function () {
    var xhr = this._xhr
    if (xhr.readyState == 4) {
      var ioError_1 = xhr.status >= 400 || xhr.status == 0
      var url_1 = this._url
      var self_3 = this
      window.setTimeout(function () {
        if (ioError_1) {
          if (true && !self_3.hasEventListener(egret.IOErrorEvent.IO_ERROR)) {
            egret.$error(1011, url_1)
          }
          self_3.dispatchEventWith(egret.IOErrorEvent.IO_ERROR)
        } else {
          self_3.dispatchEventWith(egret.Event.COMPLETE)
        }
      }, 0)
    }
  }
  WebHttpRequest.prototype.updateProgress = function (event) {
    if (event.lengthComputable) {
      egret.ProgressEvent.dispatchProgressEvent(this, egret.ProgressEvent.PROGRESS, event.loaded, event.total)
    }
  }
  return WebHttpRequest
}(egret.EventDispatcher)
