//（1）加载资源，搜索‘__proto.load=function(url,type,cache,group,ignoreCache)’，复制下面的代码覆盖该方法。
__proto.load = function (url, type, cache, group, ignoreCache) {
	(cache === void 0) && (cache = true);
	(ignoreCache === void 0) && (ignoreCache = false);
	this._url = url;
	if (url.indexOf("data:image") === 0) this._type = type = "image";
	else {
		this._type = type || (type = this.getTypeFromUrl(url));
		url = URL.formatURL(url);
	}
	this._cache = cache;
	this._data = null;
	if (!ignoreCache && Loader.loadedMap[url]) {
		this._data = Loader.loadedMap[url];
		this.event("progress", 1);
		this.event("complete", this._data);
		return;
	}
	if (group) Loader.setGroup(url, group);
	if (Loader.parserMap[type] != null) {
		this._customParse = true;
		if (((Loader.parserMap[type]) instanceof laya.utils.Handler)) Loader.parserMap[type].runWith(this);
		else Loader.parserMap[type].call(null, this);
		return;
	}
	if (type === "image" || type === "htmlimage" || type === "nativeimage") return this._loadImage(url);
	if (type === "sound") return this._loadSound(url);
	if (type === "ttf") return this._loadTTF(url);
	var contentType;
	switch (type) {
		case "atlas":
		case "plf":
			contentType = "json";
			break;
		case "font":
			contentType = "xml";
			break;
		case "pkm":
			contentType = "arraybuffer";
			break
		default:
			contentType = type;
	}
	// 添加此处代码适配
	if (qg) {
		if (url.startsWith('file://'))
			url = url.substr('file://'.length);
		var response;
		var that = this;
		if (type == 'pkm' || type == 'arraybuffer') {
			qg.readFile({
				uri: this._url,
				//alt
				encoding: 'binary',
				success: function (params) {
					response = params.text;
					that.onLoaded(response);
				},
				fail: function (params) {
					console.log(params);
				}
			});
		}
		else {
			qg.readFile({
				uri: this._url,
				encoding: "utf8",
				success: function (params) {
					response = params.text;
					if (type == 'atlas' || type == 'json') {
						response = JSON.parse(response);
					}
					if (type == "xml") {
						response = (new DOMParser()).parseFromString(response);
					}
					that.onLoaded(response);
				},
				fail: function (params) {
					console.log(params);
				}
			});
		}
		return;
	}
	//添加代码结束
	if (Loader.preLoadedMap[url]) {
		this.onLoaded(Loader.preLoadedMap[url]);
	} else {
		if (!this._http) {
			this._http = new HttpRequest();
			this._http.on("progress", this, this.onProgress);
			this._http.on("error", this, this.onError);
			this._http.on("complete", this, this.onLoaded);
		}
		this._http.send(url, null, "get", contentType);
	}
}

//（2）搜索“URL.formatURL = function (url, base)”，复制下面的代码覆盖该方法。。
URL.formatURL = function (url, base) {
	if (!url) return "null path";
	if (url.indexOf(":") > 0) return url;
	if (URL.customFormat != null) url = URL.customFormat(url, base);
	var char1 = url.charAt(0);
	if (char1 === ".") {
		return URL.formatRelativePath((base || URL.basePath) + url);
	} else if (char1 === '~') {
		return URL.rootPath + url.substring(1);
	} else if (char1 === "d") {
		if (url.indexOf("data:image") === 0) return url;
	} else if (char1 === "/") {
		return url;
	}
	if (qg) {
		return (base || 'file://') + url;
	} else {
		return (base || URL.basePath) + url;
	}
}

if (this.xs != 1 || this.ys != 1){
	this._ctx.scale(this.xs, this.ys);
	if(qg){
		var string = this.font + "";
		string = string.replace(/\d + /g, '');
		var mFontSize = parseInt(parseInt(this.font) * ((this.xs > this.ys) ? this.xs : this.ys) + "");
		this._ctx.font = mFontSize + string + "";
	}
}

__getset(0,__proto,'nativeInput',function(){
	Input.area.blur = Input.input.blur = function(){}
	return this._multiline ? Input.area :Input.input;
});

var AudioSound = function (_super) {
	function AudioSound() {
		this.url = null;
		this.audio = null;
		this.loaded = false;
		AudioSound.__super.call(this);
	}
	__class(AudioSound, 'laya.media.h5audio.AudioSound', _super);
	var __proto = AudioSound.prototype;
	__proto.dispose = function () {
		var ad = AudioSound._audioCache[this.url];
		if (ad) {
			ad.src = '';
			delete AudioSound._audioCache[this.url];
		}
	};
	__proto.load = function (url) {
		url = URL.formatURL(url);
		this.url = url;
		var ad;
		if (url == SoundManager._tMusic) {
			AudioSound._initMusicAudio();
			ad = AudioSound._musicAudio;
			if (ad.src != url) {
				AudioSound._audioCache[ad.src] = null;
				ad = null;
			}
		} else {
			ad = AudioSound._audioCache[url];
		}
		if (ad && ad.readyState >= 2) {
			this.event('complete');
			return;
		}
		if (!ad) {
			ad = qg.createInnerAudioContext()
			var src = ""
			if(/file:\/\//.test(url)){
				src = url.slice(7)
			}
			AudioSound._audioCache[url] = ad;
			ad.src = src;
			ad.play()
			var me = this;
			(function getLoadStatus() {
				if (ad.duration > 0) {
					me.length = ad.duration;
					me.loaded = true;
					me.event('complete');
					ad.stop();
				}
				else {
					setTimeout(getLoadStatus,100)
				}
			})()
		}
		this.audio = ad;
	};
	__proto.play = function (startTime, loops) {
		startTime === void 0 && (startTime = 0);
		loops === void 0 && (loops = 0);
		if (!this.url)
			return null;
		var ad;
		if (this.url == SoundManager._tMusic) {
			ad = AudioSound._musicAudio;
		} else {
			ad = AudioSound._audioCache[this.url];
		}
		if (!ad)
			return null;
		var tAd;
		tAd = Pool.getItem('audio:' + this.url);
		if (Render.isConchApp) {
			if (!tAd) {
				tAd = Browser.createElement('audio');
				tAd.src = this.url;
			}
		} else {
			if (this.url == SoundManager._tMusic) {
				AudioSound._initMusicAudio();
				tAd = AudioSound._musicAudio;
				tAd.src = this.url;
			} else {
				tAd = tAd ? tAd : ad.cloneNode(true);
			}
		}
		;
		var channel = new AudioSoundChannel(tAd);
		channel.url = this.url;
		channel.loops = loops;
		channel.startTime = startTime;
		channel.play();
		SoundManager.addChannel(channel);
		return channel;
	};
	__getset(0, __proto, 'duration', function () {
		var ad;
		ad = AudioSound._audioCache[this.url];
		if (!ad)
			return 0;
		return ad.duration;
	});
	AudioSound._initMusicAudio = function () {
		if (AudioSound._musicAudio)
			return;
		if (!AudioSound._musicAudio)
			AudioSound._musicAudio = Browser.createElement('audio');
		if (!Render.isConchApp) {
			Browser.document.addEventListener('mousedown', AudioSound._makeMusicOK);
		}
	};
	AudioSound._makeMusicOK = function () {
		Browser.document.removeEventListener('mousedown', AudioSound._makeMusicOK);
		if (!AudioSound._musicAudio.src) {
			AudioSound._musicAudio.src = '';
			AudioSound._musicAudio.load();
		} else {
			AudioSound._musicAudio.play();
		}
	};
	AudioSound._audioCache = {};
	AudioSound._musicAudio = null;
	return AudioSound;
}(EventDispatcher);